import Singleton from "./Singleton";
export default abstract class Manager<T> extends Singleton implements Map<string, T> {
    protected state: Map<string, T>;
    size: number;
    get [Symbol.toStringTag](): string;
    [Symbol.iterator](): IterableIterator<[string, T]>;
    clear(): void;
    delete(key: string): boolean;
    forEach(callbackfn: (value: T, key: string, map: Map<string, T>) => void, thisArg?: any): void;
    get(key: string): T | undefined;
    has(key: string): boolean;
    set(key: string, value: T): this;
    entries(): IterableIterator<[string, T]>;
    keys(): IterableIterator<string>;
    values(): IterableIterator<T>;
}
